/*################################################################################
  ##
  ##   Copyright (C) 2016-2023 Keith O'Hara
  ##
  ##   This file is part of the BaseMatrixOps C++ library.
  ##
  ##   Licensed under the Apache License, Version 2.0 (the "License");
  ##   you may not use this file except in compliance with the License.
  ##   You may obtain a copy of the License at
  ##
  ##       http://www.apache.org/licenses/LICENSE-2.0
  ##
  ##   Unless required by applicable law or agreed to in writing, software
  ##   distributed under the License is distributed on an "AS IS" BASIS,
  ##   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ##   See the License for the specific language governing permissions and
  ##   limitations under the License.
  ##
  ################################################################################*/

#ifndef BMO_CORE_INCLUDES
#define BMO_CORE_INCLUDES

//

#include "abs.hpp"
#include "abs_max.hpp"
#include "accu.hpp"
#include "access.hpp"
#include "array_add.hpp"
#include "array_div.hpp"
#include "array_mult.hpp"
#include "as_scalar.hpp"
#include "cholesky.hpp"
#include "constant.hpp"
#include "cos.hpp"
#include "cout.hpp"
#include "diagmat.hpp"
#include "diagvec.hpp"
#include "dot.hpp"
#include "endl.hpp"
#include "eval.hpp"
#include "exp.hpp"
#include "eye.hpp"
#include "hadamard.hpp"
#include "is_finite.hpp"
#include "inv.hpp"
#include "log.hpp"
#include "log_det.hpp"
#include "max.hpp"
#include "min.hpp"
#include "ncol.hpp"
#include "norm.hpp"
#include "ones.hpp"
#include "pow.hpp"
#include "quad_form.hpp"
#include "randi.hpp"
#include "randn.hpp"
#include "randu.hpp"
#include "set_size.hpp"
#include "set_values.hpp"
#include "size.hpp"
#include "solve.hpp"
#include "sort.hpp"
#include "sqrt.hpp"
#include "sum.hpp"
#include "trace.hpp"
#include "transpose.hpp"
#include "zeros.hpp"

//

#endif
